
-- VARIABLES --
r1 = {}          -- Raquette de joueur 1
   r1.image = Image.load("images/raquettej1.png",VRAM)   
   r1.longueur = Image.width(r1.image)          
   r1.largeur = Image.height(r1.image)                  
   r1.x = (256 / 2) - (r1.longueur / 2)            
   r1.y = 192 - r1.largeur - 5                   
   r1.vitesse = 2    
    
r2 = {}          -- Raquette du joueur 2/IA
   r2.image = Image.load("images/raquettej2.png",VRAM)   
   r2.longueur = Image.width(r2.image)           
   r2.largeur = Image.height(r2.image)           
   r2.x = (256 / 2) - (r2.longueur / 2)           
   r2.y = 5                                       
   r2.vitesse = 2   
    
balle = {}
   balle.image = Image.load("images/balle.png",VRAM)   
   balle.diametre = Image.width(balle.image)       
   balle.sensx = 1         -- sens de dplacement de la balle horizontalement 
   balle.sensy = 1         -- et verticalement                              
   balle.x = (256 / 2) - (balle.diametre / 2)   
   balle.y = (192 / 2) - (balle.diametre / 2)   
   balle.vitesse = 1      -- vitesse de dplacement de la balle horizontalement et verticalement
   balle.vitesseInitiale = 1
   
score = {}
   score.joueur1 = 0
   score.joueur2 = 0
   score.max = 5

police = Font.load("Gunplay.oft")
policeLargeur = Font.getCharHeight(police)
policeLongueur = Font.getStringWidth(police,score.joueur1.." - "..score.joueur2)

fond = Image.load("images/background.png",VRAM)

reglages = true
jeu = false
bouclePrincipale = true

Sound.loadBank("sons/soundbank.bin")
Sound.loadSFX(0)
Sound.loadSFX(1)
Sound.loadSFX(2)
Sound.loadSFX(3)
Sound.loadSFX(35)
Sound.loadMod(0)


-- BOUCLE PRINCIPALE --
while bouclePrincipale do
   ----------- CHOIX DES PARAMETRES -----------
   while reglages do
      -- REGLAGES --
	 Controls.read()
	  
      if Keys.newPress.Up then score.max = score.max + 1        --score maximum
        elseif Keys.newPress.Down then score.max = score.max -1
      end
      if score.max == 0 then score.max = 1 end
      
      if Keys.newPress.Left then              --vitesse de la balle
        balle.vitesse = balle.vitesse - 0.1
        elseif Keys.newPress.Right then balle.vitesse = balle.vitesse + 0.1
      end
      if balle.vitesse == 0 then balle.vitesse = 0.1 end
      
      if Keys.newPress.L then              -- vitesse des raquettes
        r1.vitesse, r2.vitesse = r1.vitesse - 0.1, r2.vitesse - 0.1
        elseif Keys.newPress.R then
          r1.vitesse, r2.vitesse = r1.vitesse + 0.1, r2.vitesse + 0.1
      end
      if r1.vitesse == 0 then r1.vitesse = 0.1 end
      
      balle.vitesseInitiale = balle.vitesse
      
      if Keys.held.Start then   -- Pour confirmer ses rglages et jouer
		reglages = false  
		jeu = true
	  end
	  
	  if Keys.held.Select then  --Pour quitter
		reglages = false
		bouclePrincipale = false
	  end
	  
	  -- AFFICHAGE --
	  screen.print(SCREEN_DOWN,0,0,"Select pour quitter")
      screen.print(SCREEN_DOWN,0,30,"Haut/Bas pour augm/dim le score maximum")
      screen.print(SCREEN_DOWN,0,50,"<-/-> pour dim/augm la vitesse de la balle")
      screen.print(SCREEN_DOWN,0,70,"L/R pour dim/augm la vitesse des raquettes")
      screen.print(SCREEN_UP,0,30,"SCORE MAX ="..score.max)
      screen.print(SCREEN_UP,0,60,"Vitesse de la balle ="..balle.vitesse)
      screen.print(SCREEN_UP,0,90,"Vitesse des raquettes ="..r1.vitesse)
      screen.print(SCREEN_DOWN,0,140,"START POUR CONFIRMER !!!")
      render()
   end

   ------------------- JEU ------------------
  Sound.startMod(0,PLAY_LOOP)   -- dmarrage de la musique principale
  while jeu do
	   -- MOUVEMENTS --
	   Controls.read()
	   --1.1 Dplacement de la balle                                                
	   balle.x = balle.x + (balle.sensx * balle.vitesse)          
	   balle.y = balle.y + (balle.sensy * balle.vitesse)
		
	   --1.2 On fait rebondir la balle sur les bords (gauche et droite)
	   if balle.x <= 0 or balle.x + balle.diametre >= 256 then
		 balle.sensx = -balle.sensx
	   end
		  
	   --2.1 On dplace la raquette du joueur 1
	   if Keys.held.Right then
		  r1.x = r1.x + r1.vitesse 
		  elseif Keys.held.Left then
			 r1.x = r1.x - r1.vitesse 
	   end
		  
	   --2.2 On dplace la raquette du joueur 2
	   if balle.x < r2.x then
		 r2.x = r2.x - r2.vitesse
		 elseif balle.x + balle.diametre > r2.x + r2.longueur then
		   r2.x = r2.x + r2.vitesse
	   end
		  
	   --3. On empche aux raquettes de dborder   
	   if r1.x < 0 then r1.x = 0   
		 elseif r1.x + r1.longueur > 256 then r1.x = 256 - r1.longueur   
	   end   
		  
	   if r2.x < 0 then r2.x = 0   
		 elseif r2.x + r2.longueur > 256 then r2.x = 256 - r2.longueur   
	   end
		  
	   --4.1 Collisions entre la raquette du joueur 1 et la balle	  
	   if balle.y + balle.diametre >= r1.y and balle.y + balle.diametre <= r1.y + r1.largeur and balle.x + balle.diametre >= r1.x and balle.x <= r1.x + r1.longueur then
		  balle.vitesse = balle.vitesse + 0.1      --On augmente la vitesse de dplacement de la balle  chaque collision
		  if balle.sensx > 0 and balle.x + balle.diametre >= r1.x - 3 and balle.x + balle.diametre <= r1.x + 3 then                                      -- Rebond sur les diagonales  
			balle.sensx = -balle.sensx                                                                                                                  -- diffrent selon
			elseif balle.sensx < 0 and balle.x >= r1.x + r1.longueur - 3 and balle.x <= r1.x + r1.longueur + 3 then                                     -- le sens de dplacement de la balle
				balle.sensx = -balle.sensx                                                                                                               -- sur l'axe x.
		  end      
		  balle.sensy = -balle.sensy
		  Sound.startSFX(3)  		 --son.collision 
	   end
	   
       --4.2 Collisions	entre la raquette du joueur 2 et la balle
	   if balle.y >= r2.y and balle.y <= r2.y + r2.largeur and balle.x + balle.diametre >= r2.x and balle.x <= r2.x + r2.longueur then
		   balle.vitesse = balle.vitesse + 0.1     --On augmente la vitesse de dplacement de la balle  chaque collision              
		   if balle.sensx > 0 and balle.x + balle.diametre >= r2.x - 3 and balle.x + balle.diametre <= r2.x + 3 then                                     -- Rebond sur les diagonales  
			  balle.sensx = -balle.sensx                                                                                                                 -- diffrent selon
			  elseif balle.sensx < 0 and balle.x >= r2.x + r2.longueur - 3 and balle.x <= r2.x + r2.longueur + 3 then                                    -- le sens de dplacement de la balle
				 balle.sensx = -balle.sensx                                                                                                              -- sur l'axe x.
		   end
		   balle.sensy = -balle.sensy
		   Sound.startSFX(3)          --son.collision
	   end
			
	   --5.1 Si un point est marqu :
	   if balle.y <= 0 or balle.y + balle.diametre >= 192 then
		 if balle.y <= 0 then score.joueur1 = score.joueur1 + 1            -- Comptage des points
		   elseif balle.y + balle.diametre >= 192 then score.joueur2 = score.joueur2 + 1
		 end
		 
		 balle.x = (256 / 2) - (balle.diametre / 2)
		 balle.y = (192 / 2) - (balle.diametre / 2)
		 r1.x = (256 / 2) - (r1.longueur / 2) 
		 r2.x = (256 / 2) - (r2.longueur / 2)
			
		 balle.sensx, balle.sensy = -balle.sensx, -balle.sensy
		 balle.vitesse = balle.vitesseInitiale
			
		 if score.joueur1 ~= score.max and score.joueur2 ~= score.max then Sound.startSFX(0) end  --son.but
	   end
		  
	   --5.2 On remet le score  zero et on relance le menu si un joueur atteint le nompre de points max
	   if score.joueur1 == score.max or score.joueur2 == score.max then 
		 if score.joueur1 > score.joueur2 then
		   if score.joueur2 == 0 then Sound.startSFX(2)   --son.perfect
			 else Sound.startSFX(35)                      --son.win
		   end
		  elseif score.joueur2 > score.joueur1 then
		   Sound.startSFX(1)                              --son.lose
		 end
		 score.joueur1, score.joueur2 = 0,0
		 jeu, reglages = false, true
	   end
       
	   --6. Autres
	   Sound.setModVolume(200)
	   if Keys.held.Select then    --Pour quitter
	      jeu, bouclePrincipale = false, false
	   end
	   
	   -- AFFICHAGE --
	   screen.print(SCREEN_DOWN,0,0,"Select pour quitter")
	   Font.print(SCREEN_DOWN,police,(256/2)-(policeLongueur/2),(192/2)-(policeLargeur /2),score.joueur1.." - "..score.joueur2,Color.new(10,22,12))  --La colorisation ne fonctionne pas sur hardware.
	   screen.blit(SCREEN_UP,0,0,fond)
	   screen.blit(SCREEN_UP,r1.x,r1.y,r1.image)
	   screen.blit(SCREEN_UP,r2.x,r2.y,r2.image)
	   screen.blit(SCREEN_UP,balle.x,balle.y,balle.image)   
	   render()
	end
end
Sound.stop()   -- On arrte la musique


-- DESTRUCTION DES VARIABLES --
Image.destroy(r1.image)
Image.destroy(r2.image)
Image.destroy(balle.image)
Image.destroy(fond)

Sound.unloadBank()
Sound.unloadSFX(0)
Sound.unloadSFX(1)
Sound.unloadSFX(2)
Sound.unloadSFX(3)
Sound.unloadSFX(35)
Sound.unloadMod(0)   --Malheureusement, il faudra redmarrer la DS  la fermeture du jeu.

r1, r2, balle, score = nil, nil, nil, nil
police, policeLargeur, policeLongueur = nil, nil, nil
reglages, jeu, fond, bouclePrincipale = nil, nil, nil, nil
